/*
 * cleanup - examine a cached file, and if it meets the criteria for
 * being old, remove it
 *
 * this criterion is currently very simple - we're still experimenting
 * 
 * Reinier Post
 *
 * $Log: cleanup.h,v $
 * Revision 0.14  1994/05/17  13:37:32  reinpost
 * slight interface change; cache_prefix is now exported to html.c
 *
 * Revision 0.14  1994/05/17  13:37:32  reinpost
 * slight interface change; cache_prefix is now exported to html.c
 *
 * Revision 0.13  1994/05/03  19:30:26  reinpost
 * some new code but we don't use it yet
 *
 * Revision 0.11  1994/03/25  20:43:57  reinpost
 * a new routine to support the d directive
 *
 * Revision 0.11  1994/03/25  20:43:57  reinpost
 * a new routine to support the d directive
 *
 * Revision 0.9  1994/03/02  21:22:54  reinpost
 * some interface changes
 *
 * Revision 0.9  1994/03/02  21:22:54  reinpost
 * some interface changes
 *
 * Revision 0.8  1994/02/25  20:19:55  reinpost
 * name change
 *
 * Revision 0.7  1994/02/18  13:19:54  reinpost
 * geen idee wat hier veranderd is
 *
 * Revision 0.5  1994/02/17  10:28:26  reinpost
 * unfinished
 */

/* arguments to cached_file_status() */
#define CF_CLEANUP 1
#define CF_REFRESH 2

extern int url_is_cached(char *url, char *query_string);
/* checks whether or not the URL is stored in cache */
/* this is done by seeing if its refresh rate > 0 */

extern char *conf_cache_prefix(char *url);
/* produces a malloc-ed string consisting of the cache_prefix to be used */
/* in the translation of links in this document */
/* (this may not be equal to cache_prefix if the t directive is used, */
/* which may be useful if the d directive is used as well) */

extern int cached_file_status(char *file, int directive);
/* returns the following codes: */
#define CF_OLD 1  /* document is 'old' */
#define CF_NEW 2  /* document is 'new' */
#define CF_NOT 3  /* document is not present */
#define CF_ERR -1 /* an error occurred trying to get info on the document */

/* cached_file_status(file,CF_REFRESH) asks if it is necessary to refresh */
/* the file, CF_CLEANUP asks whether deleting it is allowed */

extern int remove_cached_file(char *file);
/* -1 on failure, 0 on success */

extern char *url_to_remote_source(char *url);
/* produces a malloc-ed string consisting of a 'redirected' URL */
/* redirection is performed according to the d directive in expire.conf */
